HDU 6041 I Curse Myself(点双联通加集合合并求前K大) 2017多校第一场
题意:
给出一个仙人掌图,然后求他的前K小生成树。
思路:
先给出官方题解
由于图是一个仙人掌,所以显然对于图上的每一个环都需要从环上取出一条边删掉。所以问题就变
为有 M 个集合,每个集合里面都有一堆数字,要从每个集合中选择一个恰好一个数加起
来。求所有的这样的和中,前 K 大的是哪些。这就是一个经典问题了。
点双联通就不说了 都一眼能看出来做法就是缩点之后每个环每次取一个,然后找最大的k个所以这道题的难点就在这里,做法当然是不知道啦,看了题解和博客才懂的。以前做过两个集合合并的,这个是k个合并,和两个集合合并差不多,不过感觉很厉害啊。。就是先两个合并,然后和第三个合并,在和第四个,然后就可以了。。复杂度的话题解说的O(KM)。。。那就O(KM)吧,反正这个是真不会证过程挺厉害的 在合并的时候
void merge(vector<int> &V , vector<int> B) {
priority_queue< opt > Q;
for (int i = 0 ; i < B.size() ; ++ i) {
Q.push((opt) {V[0] + B[i] , i , 0});
}
W.resize(0);
while (W.size() < K && !Q.empty()) {
auto it = Q.top(); Q.pop();
W.push_back(it.w);
if (it.y + 1 < V.size()) {
++ it.y;
Q.push((opt) {B[it.x] + V[it.y] , it.x , it.y});
}
}
V = W;
}
最开始一直没看懂 看了一天呀。。。 后来想通了感觉还是挺简单的,然后在本机跑,没开O2跑了大半辈子。。。
具体过程其实就是对于每个已经合并了的数组,最开始让他最大的和B数组合并,然后对于已经合并了的数组,如果当前
的这一位被push进答案数组,那么就把先合并数组的次大的和B数组的当前数字合并就可以了。
思路挺厉害的~
代码就贴标程的吧~
#include <bits/stdc++.h>
using namespace std;
const int N = 1005;
int n , m , K; struct opt {
int w , x , y;
bool operator < (const opt& R) const {
return w < R.w;
}
}; vector<int> W;
void merge(vector<int> &V , vector<int> B) {
priority_queue< opt > Q;
for (int i = 0 ; i < B.size() ; ++ i) {
Q.push((opt) {V[0] + B[i] , i , 0});
}
W.resize(0);
while (W.size() < K && !Q.empty()) {
auto it = Q.top(); Q.pop();
W.push_back(it.w);
if (it.y + 1 < V.size()) {
++ it.y;
Q.push((opt) {B[it.x] + V[it.y] , it.x , it.y});
}
}
V = W;
} int pre[N] , mcnt;
struct edge {
int x , w , next;
} e[N << 2]; vector<int> res; int dfn[N] , low[N] , ncnt;
stack<int> S; void dfs(int x , int fa) {
dfn[x] = low[x] = ++ ncnt;
for (int i = pre[x] ; ~i ; i = e[i].next) {
int y = e[i].x;
if (!dfn[y]) {
S.push(i);
dfs(y , i ^ 1);
low[x] = min(low[x] , low[y]);
if (low[y] > dfn[x]) {}//(x , y) is bridge
if (low[y] >= dfn[x]) {
int j;
vector<int> V;
do {
j = S.top();
S.pop();
V.push_back(e[j].w);
} while (j != i);
if (V.size() > 1) {
//cout << V.size() << endl;
//for (auto &x : V) cout << x << ' '; cout << endl;
merge(res , V);
}
}
} else if (i != fa && dfn[y] < dfn[x])
S.push(i) , low[x] = min(low[x] , dfn[y]);
}
} void work() {
memset(pre , -1 , sizeof(pre));
mcnt = ncnt = 0;
int sum = 0;
for (int i = 0 ; i < m ; ++ i) {
int x , y , z;
scanf("%d%d%d" , &x , &y , &z);
e[mcnt] = (edge) {y , z , pre[x]} , pre[x] = mcnt ++;
e[mcnt] = (edge) {x , z , pre[y]} , pre[y] = mcnt ++;
sum += z;
}
scanf("%d" , &K);
res.resize(0);
res.push_back(0);
memset(dfn , 0 , sizeof(dfn));
dfs(1 , 0);
int w = 0;
for (int i = 0 ; i < res.size() ; ++ i) {
w += (i + 1) * (sum - res[i]);
}
static int ca = 0;
printf("Case #%d: %u\n" , ++ ca , w);
} int main() {
res.reserve(100001);
W.reserve(100001);
while (~scanf("%d%d" , &n , &m)) {
work();
}
return 0;
}
HDU 6041 I Curse Myself(点双联通加集合合并求前K大) 2017多校第一场的更多相关文章
- hdu 6044 : Limited Permutation (2017 多校第一场 1012) 【输入挂 组合数学】
题目链接 参考博客: http://blog.csdn.net/jinglinxiao/article/details/76165353 http://blog.csdn.net/qq_3175920 ...
- hdu 6035:Colorful Tree (2017 多校第一场 1003) 【树形dp】
题目链接 单独考虑每一种颜色,答案就是对于每种颜色至少经过一次这种的路径条数之和.反过来思考只需要求有多少条路径没有经过这种颜色即可. 具体实现过程比较复杂,很神奇的一个树形dp,下面给出一个含较详细 ...
- HDU 6041.I Curse Myself 无向仙人掌图
I Curse Myself Time Limit: 8000/4000 MS (Java/Others) Memory Limit: 131072/131072 K (Java/Others) ...
- HDU 6041 - I Curse Myself | 2017 Multi-University Training Contest 1
和题解大致相同的思路 /* HDU 6041 - I Curse Myself [ 图论,找环,最大k和 ] | 2017 Multi-University Training Contest 1 题意 ...
- HDU 2639 01背包求第k大
Bone Collector II Time Limit: 5000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others ...
- HDU 6041 I Curse Myself(二分+搜索)
[题目链接] http://acm.hdu.edu.cn/showproblem.php?pid=6041 [题目大意] 给出一个仙人掌图,求第k小生成树 [题解] 首先找到仙人掌图上的环,现在的问题 ...
- hdu 6041 I Curse Myself
题目: 点这里OvO http://acm.hdu.edu.cn/showproblem.php?pid=6041 2017 Multi-University Training Contest - T ...
- lightoj 1300 边双联通分量+交叉染色求奇圈
题目链接:http://lightoj.com/volume_showproblem.php?problem=1300 边双连通分量首先dfs找出桥并标记,然后dfs交叉着色找奇圈上的点.这题只要求在 ...
- poj 3177&&3352 求边双联通分量,先求桥,然后求分量( 临界表代码)
/*这道题是没有重边的,求加几条边构成双联通,求边联通分量,先求出桥然后缩点,成一个棵树 找叶子节点的个数*/ #include<stdio.h>//用容器写在3177这个题上会超内存,但 ...
随机推荐
- crontab计划任务监控nginx服务器
#!/bin/bash ps axu |grep 'nginx' |grep -v 'grep' &>/dev/null ] then echo "准备重启nginx....& ...
- HDU 3499【最短路】
题意: 给你一幅图,然后起点终点,然后有一个条件是可以使某条边的花费减半,求最短路的最小花费. 思路: (来自大哥) 最短路的时候多一维,途中是否有花费减半的边: 然后转移,如果上一条有减半的,这一条 ...
- game学习资源收集
一些国外网站 游戏ai相关 http://aigamedev.com/ http://www.gdcvault.com/ http://www-cs-students.stanford.edu/~am ...
- Codevs 3409 搬运礼物
3409 搬运礼物 CodeVS原创 时间限制: 1 s 空间限制: 64000 KB 题目等级 : 青铜 Bronze 题解 题目描述 Description 小浣熊松松特别喜欢交 ...
- Codevs 3112 二叉树计数
3112 二叉树计数 题目描述 Description 一个有n个结点的二叉树总共有多少种形态 输入描述 Input Description 读入一个正整数n 输出描述 Output Descript ...
- P1290-关灯
描述 Description 宁智贤得到了一份有趣而高薪的工作.每天早晨她必须关掉她所在村庄的街灯.所有的街灯都被设置在一条直路的同一侧.宁智贤每晚到早晨5点钟都在晚会上,然后她开始关灯.开始时,她站 ...
- JPA-day04 核心API 一级缓存 主键生成策略 实体对象的4种状态 多对一关系 延迟加载
- 捕获异常try-catch-finally
异常分类 try-carch-finally出现规则 return关键字的使用 finally中慎用return,虽然语法上没错,但是由于finally的强制执行,影响逻辑上需要return的值 pa ...
- HDU 1028 Ignatius and the Princess III dp整数划分
http://acm.hdu.edu.cn/showproblem.php?pid=1028 dp[i][j]表示数值为i,然后最小拆分的那个数是j的时候的总和. 1 = 1 2 = 1 + 1 . ...
- c#操作ecxel的一些资源(downmoon搜集)
c#操作ecxel的一些资源(downmoon搜集) 工作需要,邀月收集了几个操作excel的资源. 1.如何:使用 COM Interop 创建 Excel 电子表格(C# 编程指南)http:/ ...